<?php

// Film Archive

function film_init() {
  $labels = array(
    'name' => 'Films',
    'singular_name' => 'Film',
    'add_new' => 'Add New',
    'add_new_item' => 'Add New Film',
    'edit_item' => 'Edit Film',
    'new_item' => 'New Film',
    'all_items' => 'All Films',
    'view_item' => 'View Film',
    'search_items' => 'Search Films',
    'not_found' =>  'No films found',
    'not_found_in_trash' => 'No films found in Trash', 
    'parent_item_colon' => '',
    'menu_name' => 'Film Archive'
  );

  $args = array(
    'labels' => $labels,
    'public' => true,
    'publicly_queryable' => true,
    'show_ui' => true, 
    'show_in_menu' => true, 
    'query_var' => true,
    'rewrite' => array( 'slug' => 'films' ),
    'capability_type' => 'post',
    'has_archive' => true, 
	'taxonomies' => array('year'),
    'hierarchical' => false,
    'menu_position' => null,
    'supports' => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt', 'comments' )
  ); 

  register_post_type( 'film', $args );
  
  register_taxonomy(
		'year',
		'film',
		array(
			'label' => __( 'Category' ),
			'hierarchical' => true,
			'rewrite' => array( 'slug' => 'archive' )
		)
	);
}
add_action( 'init', 'film_init' );

?>