<?php
$prefix = 'meta_';

global $meta_boxes;

$meta_boxes = array();

// 1st meta box
$meta_boxes[] = array(
	// Meta box id, UNIQUE per meta box. Optional since 4.1.5
	'id' => 'standard',

	// Meta box title - Will appear at the drag and drop handle bar. Required.
	'title' => 'Advanced Settings',

	'pages' => array( 'page' ),

	'context' => 'normal',

	'priority' => 'high',

	'fields' => array(
		array(
			'name'  => 'Slug',
			'id'    => "{$prefix}slug",
			'desc'  => 'Film Archive Category, e.g. 2012',
			'type'  => 'text',
		),

		array(
			'name'     => 'Header Icon',
			'id'       => "{$prefix}icon",
			'type'     => 'select',
			// Array of 'value' => 'Label' pairs for select box
			'options'  => array(
				'' => 'None',
				'icon-film' => 'Film / Video',
				'icon-plus-sign' => 'Support / Help',
				'icon-rss' => 'News',
				'icon-comments' => 'Community',
				'icon-calendar' => 'Events',
				'icon-time' => 'Time',
				'icon-home' => 'Location / Place',
			),
			// Select multiple values, optional. Default is false.
			'multiple' => false,
		)
	)
);

/********************* META BOX REGISTERING ***********************/

/**
 * Register meta boxes
 *
 * @return void
 */
function films_register_meta_boxes()
{
	// Make sure there's no errors when the plugin is deactivated or during upgrade
	if ( !class_exists( 'RW_Meta_Box' ) )
		return;

	global $meta_boxes;
	foreach ( $meta_boxes as $meta_box )
	{
		new RW_Meta_Box( $meta_box );
	}
}
// Hook to 'admin_init' to make sure the meta box class is loaded before
// (in case using the meta box class in another plugin)
// This is also helpful for some conditionals like checking page template, categories, etc.
add_action( 'admin_init', 'films_register_meta_boxes' );