<?php

add_filter('show_admin_bar', '__return_false');

// Scripts and Styles

function richard_scripts() {
	wp_enqueue_style( 'web-fonts', 'http://fonts.googleapis.com/css?family=Lato:400,100,300,700,900,100italic,300italic,400italic,700italic,900italic|Jockey+One');
	wp_enqueue_style('font-awesome', 'http://netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css', array(), '4.0.3');
	wp_enqueue_style('foundation', get_template_directory_uri() . '/css/foundation.css', array(), '1.0.0');
	wp_enqueue_script( 'modernizr', get_template_directory_uri() . '/js/vendor/modernizr.js', array(), '1.0.0', false );
	wp_enqueue_script( 'jquery', get_template_directory_uri() . '/js/vendor/jquery.js', array(), '1.0.0', true );
	wp_enqueue_script( 'foundation', get_template_directory_uri() . '/js/foundation.min.js', array(), '1.0.0', true );
}

add_action( 'wp_enqueue_scripts', 'richard_scripts' );

 //Register area for custom menu
function register_my_menu() {
    register_nav_menu( 'primary-menu', __( 'Primary Menu' ) );
}

add_action( 'init', 'register_my_menu' );

add_theme_support('post-thumbnails');

add_image_size('work',562, 280, true);

include_once('includes/post-types.php');

// Excerpt Condiguration

function new_excerpt_more( $more ) {
	return '...';
}
add_filter('excerpt_more', 'new_excerpt_more');

function custom_excerpt_length( $length ) {
	return 20;
}
add_filter( 'excerpt_length', 'custom_excerpt_length', 999 );

if( class_exists( 'kdMultipleFeaturedImages' ) ) {

        $args = array(
                'id' => 'featured-image-2',
                'post_type' => 'portfolio',      // Set this to post or page
                'labels' => array(
                    'name'      => 'Work Page Image',
                    'set'       => 'Set work page image',
                    'remove'    => 'Remove work page image',
                    'use'       => 'Use as work page image',
                )
        );

        $args2 = array(
                'id' => 'featured-image-3',
                'post_type' => 'portfolio',      // Set this to post or page
                'labels' => array(
                    'name'      => 'Image 1',
                    'set'       => 'Set image 1',
                    'remove'    => 'Remove image 1',
                    'use'       => 'Use as image 1',
                ));

        $args3 = array(
                'id' => 'featured-image-4',
                'post_type' => 'portfolio',      // Set this to post or page
                'labels' => array(
                    'name'      => 'Image 2',
                    'set'       => 'Set image 2',
                    'remove'    => 'Remove image 2',
                    'use'       => 'Use as image 2',
                )
            );

        $args4 = array(
                'id' => 'featured-image-5',
                'post_type' => 'portfolio',      // Set this to post or page
                'labels' => array(
                    'name'      => 'Image 3',
                    'set'       => 'Set image 3',
                    'remove'    => 'Remove image 3',
                    'use'       => 'Use as image 3',
                )
            );

        $args5 = array(
                'id' => 'featured-image-6',
                'post_type' => 'portfolio',      // Set this to post or page
                'labels' => array(
                    'name'      => 'Image 4',
                    'set'       => 'Set image 4',
                    'remove'    => 'Remove image 4',
                    'use'       => 'Use as image 4',
                )
            );

        $args6 = array(
                'id' => 'featured-image-7',
                'post_type' => 'portfolio',      // Set this to post or page
                'labels' => array(
                    'name'      => 'Image 5',
                    'set'       => 'Set image 5',
                    'remove'    => 'Remove image 5',
                    'use'       => 'Use as image 5',
                )
            );

        $args7 = array(
                'id' => 'featured-image-8',
                'post_type' => 'portfolio',      // Set this to post or page
                'labels' => array(
                    'name'      => 'Image 6',
                    'set'       => 'Set image 6',
                    'remove'    => 'Remove image 6',
                    'use'       => 'Use as image 6',
                )
            );


        new kdMultipleFeaturedImages( $args );
        new kdMultipleFeaturedImages( $args2 );
        new kdMultipleFeaturedImages( $args3 );
        new kdMultipleFeaturedImages( $args4 );
        new kdMultipleFeaturedImages( $args5 );
        new kdMultipleFeaturedImages( $args6 );
        new kdMultipleFeaturedImages( $args7 );
}

function browser( $atts, $content = null ) {
    extract(shortcode_atts(array(
        "title" => ''
    ), $atts));
    $html = '<div class="robrowser full">';
    $html .= '<div class="head">';
    $html .= '<ul class="buttons">';
    $html .= '<li class="red"></li>';
    $html .= '<li class="yellow"></li>';
    $html .= '<li class="green"></li>';
    $html .= '</ul>';
    $html .= '<div class="title hide-for-small-only">'.$title;
    $html .= '</div>';
    $html .= '<div class="clearfix"></div>';
    $html .= '</div>';
    $html .= '<div class="screenshot">';
    $html .= '<div class="image">';
    $html .= '<div class="shadow"></div>';
    $html .= $content;
    $html .= '</div></div></div>';

    return $html;
}

add_shortcode("browser", "browser");

add_filter('nav_menu_css_class' , 'special_nav_class' , 10 , 2);
function special_nav_class($classes, $item){
     if( in_array('current-menu-item', $classes) ){
             $classes[] = 'active ';
     }
     return $classes;
}

?>