<!doctype html>
<html class="no-js" <?php language_attributes(); ?>>
  <head>
    <meta charset="<?php bloginfo( 'charset' ); ?>" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title><?php wp_title ( '|', true,'right' ); ?></title>
    <link rel="profile" href="http://gmpg.org/xfn/11" />
    <link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
    <?php wp_head(); ?>
    <link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
    <script src="<?php bloginfo('template_directory');?>/js/vendor/modernizr.js"></script>
    <!--[if lt IE 9]>
  <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.6.2/html5shiv.js"></script>
  <script src="//s3.amazonaws.com/nwapi/nwmatcher/nwmatcher-1.2.5-min.js"></script>
  <script src="//html5base.googlecode.com/svn-history/r38/trunk/js/selectivizr-1.0.3b.js"></script>
  <script src="//cdnjs.cloudflare.com/ajax/libs/respond.js/1.1.0/respond.min.js"></script>
<![endif]-->
  </head>
  <body>
  <?php if(is_front_page()): ?>
    <div class="loading-screen">
      <div class="richard"><img src="<?php bloginfo('template_directory');?>/img/logo-white.svg" alt="Richard Outram" class="svg"/></div>
      <div class="loading-bar">
      </div>
    </div>
    <div id="preload1"></div>
  <?php endif; ?>
    <header <?php if(is_front_page()) { echo 'class="home"'; } ?>>
      <div class="row">
        <div class="large-4 medium-2  small-4 columns">
          <div class="logo">
            <a href="<?php bloginfo('url'); ?>"><img src="<?php bloginfo('template_directory');?>/img/logo.svg" alt="Richard Outram" class="svg" /></a>
          </div>
        </div>
        <div class="large-4 medium-5 small-8  columns">
            <?php wp_nav_menu( array( 'sort_column' => 'menu_order', 'menu_class' => 'inline-list','container' => 'false', 'theme_location' => 'primary-menu', 'link_before' => '<span>', 'link_after' => '</span>') ); ?>
        </div>
        <div class="large-4 medium-5 small-6 hide-for-small columns">
          <a class="button right" href="#start-a-project">Start a Project <i class="fa fa-arrow-down"></i></a>
        </div>
      </div>
    </header>