<?php /* Template Name: Profile */ ?>
<?php get_header(); ?>


<div id="content">
	<?php if(have_posts()) : ?><?php while(have_posts()) : the_post(); ?>
    <div class="spacer"></div>
    <section class="wood">
      <div class="body">
      <div class="row-title">
        <h2><?php the_title();?></h2>
      </div>
      <div class="row">
        <div class="small-11 small-centered columns text-center">
          <?php the_content();?>
        </div>
      </div>
      <div class="row no-margin-bottom">
      <div class="small-12 columns">
        <div class="identity paper paper-curl">
        <div class="row">
          <div class="small-12 medium-4 large-4 columns">
            <div class="iconspace">
              <div class="icon text-center right hide-for-small"><i class="fa fa-user"></i></div>
              <h2 class="no-margin">A little about me</h2>
            </div>
          </div>
          <div class="small-12 medium-8 large-8 columns">
            <div class="pad">
            <p>My name is Richard and I currently live in the Yorkshire city of Sheffield. I specialise in designing and building <a href="<?php echo get_permalink(71); ?>" title="Responsive web design in Sheffield, Yorkshire.">responsive websites</a>, <a href="<?php echo get_permalink(18); ?>" title="Branding, Identity & Logo design in Sheffield, Yorkshire.">branding</a> &amp; <a href="<?php echo get_permalink(16); ?>" title="Mobile web application design in Sheffield, Yorkshire.">user-experiences</a>. I am currently <a href="#start-a-project">available for hire</a>.</p>
            <p>Just recently, in June 2013. I finished in a degree called ‘Design for Digital Media’ that I did at the University of Salford. It was a fantastic cource expanding my creative thinking on all levels.</p>
            </div>
          </div>
        </div> 
        <div class="row">
          <div class="small-12 medium-4 large-4 columns">
          <div class="iconspace">
            <div class="icon text-center right iusers hide-for-small"><i class="fa fa-users"></i></div>
            <h2 class="no-margin">I have helped</h2>
          </div>
          </div>
          <div class="small-12 medium-8 large-8 columns">
            <div class="pad">
              <p>In the past I have worked individuals, teams, start-ups and businesses. I love to understand my clients business / product and outline digital plans that help them achieve their goals. I have worked for a couple of creative agencies on a freelance basis for the past 4 years. I also help with a non-profit film production charity named Clapperboard that helps teach teenagers practical film production skills in schools &ampd colleges.</p>
              <p>My ideal project would be one where by I create branding for a product; then to develop that in to a bespoke online experience that engages the user.</p>
            </div>
          </div>
        </div> 
          
          <div class="row no-margin-bottom">
          <div class="small-12 medium-4 large-4 columns">
            <div class="iconspace">
              <div class="icon text-center right iusers hide-for-small"><i class="fa fa-cogs"></i></div>
              <h2 class="no-margin">My work process</h2>
            </div>
          </div>
          <div class="small-12 medium-8 large-8 columns">
          <div class="pad">
            <p>For any project I believe you need to have a solid foundation of research to begin a successful bespoke digital solution. A lot of the time I start by gathering relevant imagery to create a mood board. A lot of my great ideas in the past have come through this.</p>
            <p>Digital designs need to be user-centric, which means that something is created based on what someone wants. This means I frequently check to ask myself, <i>'what is best for my user?'</i>.</p>
            <p>I build a lot of my websites with Wordpress, so my clients can administer content easilly online from anywhere. It also has an excellent catalog of features allowing websites to be created much faster. In front of the Wordpress; I design and code my websites using HTML, CSS (a touch of SASS and LESS) &amp; jQuery.</p>
          </div>
          </div>
        </div>   
        </div>
        </div>
      </div>
      <div class="row">
        <div class="small-12 small-centered columns text-center">
          <div class="identity paper paper-curl">
          <h2>I have worked on projects involving</h2>
          <div class="experience">
            <span>Typography</span>
            <span>Motion Graphics</span>
            <span>Poster Campaigns</span>
            <span>Branding &amp; Identity</span>
            <span>3D Modelling &amp; Animation</span>
            <span>Web Design</span>
            <span>App Concept &amp; Interaction</span>
          </div>
          </div>
          <div class="identity paper paper-curl">
          <h2>I would rate my technical proficiency</h2>
          <div class="svg-container" id="skillchart">
            <div class="line"></div>
            <div class="line l2"></div>
            <div class="line l3"></div>
            <div class="line l4"></div>
            <svg class="svg-content skills" preserveAspectRatio="xMinYMin meet" viewBox="0 0  500 500" version="1.1">
              <filter id="drop-shadow">
                <feGaussianBlur in="SourceAlpha" stdDeviation="0"/>
                <feOffset dx="0.5" dy="0.5" result="offsetblur"/>
                <feFlood flood-color="rgba(0,0,0,0.3)"/>
                <feComposite in2="offsetblur" operator="in"/>
                <feMerge>
                <feMergeNode/>
                <feMergeNode in="SourceGraphic"/>
                </feMerge>
              </filter>
              <polygon points="0,100 66,8 122,100" fill="#b0cc64" opacity="0.9" stroke="rgba(0,0,0,0.05)" stroke-width="1"/>
                <text x="34" y="70" fill="white" filter="url(#drop-shadow)">Photoshop</text>
                <polygon points="92.351,100 146,40 209,100" fill="#F89C44" opacity="0.9" stroke="rgba(0,0,0,0.05)" stroke-width="1"/>
                <text x="125" y="79" fill="white" filter="url(#drop-shadow)">Illustrator</text>
                <polygon points="169.08,100 246,9 305,100" fill="#576ab1" opacity="0.9" stroke="rgba(0,0,0,0.05)" stroke-width="1"/>
                <text x="208" y="71" fill="white" filter="url(#drop-shadow)">HTML &amp; CSS</text>
                <polygon points="267.175,100 332,44 401.146,100" fill="#75c375" opacity="0.9" stroke="rgba(0,0,0,0.05)" stroke-width="1"/>
                <text x="317" y="81" fill="white" filter="url(#drop-shadow)">jQuery</text>
                <polygon points="375,100 430,35 485,100" fill="#7AD1F0" opacity="0.9" stroke="rgba(0,0,0,0.05)" stroke-width="1"/>
                <text x="405" y="80" fill="white" filter="url(#drop-shadow)">Wordpress</text>
            </svg>
          </div>
          <ul class="mobskills">
            <li id="photoshop"><span><span>Photoshop</span></span></li>
            <li id="illustrator"><span><span>Illustrator</span></span></li>
            <li id="html"><span><span>HTML &amp; CSS</span></span></li>
            <li id="jquery"><span><span>jQuery</span></span></li>
            <li id="wordpress"><span><span>Wordpress</span></span></li>
          </ul>
          </div>
        </div>
      </div>
    </div>
    </section>

    <section id="creativejourney" class="wood shade">
      <div class="body">
      <div class="row-title">
        <h2>Past - Present</h2>
      </div>
        <div class="row">
          <div class="small-12 columns">
            <div class="journey text-center">
              <div class="row">
                <div class="small-8 medium-5 columns">
                  <div class="entry up60f longline">
                    <p>I began teaching myself Photoshop Elements and started following photo maniupluation &amp; web design tutorials.</p>
                  </div>
                </div>
                <div class="small-8 medium-5 medium-offset-2 columns">
                  <div class="date alt">2007</div>
                  <div class="entry down60 alt">
                    <p>I built my first website using HTML and CSS. The old process of slicing a website up and using tables.</p>
                  </div>
                </div>
              </div>
              <div class="row">
                <div class="small-8 medium-5 columns">
                <div class="date">2009</div>
                  <div class="entry up80 longline">
                    <p>I completed a BTEC National Diploma in Interactive Media with a distinction while working part-time for Direct Computers doing web design.</p>
                  </div>
                </div>
                <div class="small-8 medium-5 medium-offset-2 columns">
                  <div class="date alt">2010</div>
                  <div class="entry alt down60">
                    <p>I started a bachelor’s degree titled Design for Digital Media at the uni of Salford.</p>
                  </div>
                </div>
              </div>
              <div class="row">
              <div class="small-8 medium-5 columns">
                <div class="date">2011</div>
                  <div class="entry up60 longline">
                    <p>I started helping out <a href="http://www.clapperboarduk.com/" target="_blank">Clapperboard UK</a> as a volunteer</p>
                  </div>
                </div>
                <div class="small-8 medium-5 medium-offset-2 columns">
                <div class="date alt">2012</div>
                  <div class="entry down60 alt">
                    <p>I worked doing front-end web development for 4 months at an Manchester based agency AKA Creative. It was a part of my degree as an extended work placement.</p>
                  </div>
                </div>
                
              </div>
              <div class="row gray-cover">
              <div class="small-8 medium-5 columns">
                  <div class="date">2013</div>
                  <div class="entry up120 longline">
                    <p>I finished my degree and graduated with a 2:1. Very happy to that I did the course.</p>
                    <p>I got a job working as the lead creative for a company named eServer Supplies. I spent a lot of time developing their brand &amp; Magento store.</p>
                  </div>
                </div>
                <div class="small-8 medium-5 medium-offset-2 columns">
                <div class="date alt">2014</div>
                  <div class="entry down120 alt">
                    <p>I decided to focus all my time and effort working self-employed as a freelancer.</p>
                  </div>
                </div>
                <div class="clearfix"></div>
              </div>
            </div>
          </div>
          </div>
        </div>
      </div>
    </section>
<?php endwhile; endif; ?>

<?php get_template_part( 'includes/section', 'services'); ?>

</div>

<?php get_template_part( 'includes/section', 'project'); ?>
<?php get_footer(); ?>