<!doctype html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js"> <!--<![endif]-->
<head>
  <meta charset="<?php bloginfo( 'charset' ); ?>" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1">
  <title>Rieach - Web & User-Experience (UX) Design Sheffield</title>
  <link rel="apple-touch-icon" href="<?php bloginfo('template_url'); ?>/images/apple-icons/apple-touch-icon-precomposed.png" />
  <link rel="apple-touch-icon" sizes="57x57" href="<?php bloginfo('template_url'); ?>/images/apple-icons/apple-touch-icon-57x57-precomposed.png" />
  <link rel="apple-touch-icon" sizes="72x72" href="<?php bloginfo('template_url'); ?>/images/apple-icons/apple-touch-icon-72x72-precomposed.png" />
  <link rel="apple-touch-icon" sizes="114x114" href="<?php bloginfo('template_url'); ?>/images/apple-icons/apple-touch-icon-114x114-precomposed.png" />
  <link rel="apple-touch-icon" sizes="144x144" href="<?php bloginfo('template_url'); ?>/images/apple-icons/apple-touch-icon-144x144-precomposed.png" />
  <meta name="msapplication-TileImage" content="<?php bloginfo('template_url'); ?>/images/apple-icons/apple-touch-icon-144x144-precomposed.png">
  <meta name="msapplication-TileColor" content="#ffffff">
  <!-- Modernizr -->
  <script src="<?php bloginfo('template_url'); ?>/js/libs/modernizr-2.6.2.min.js"></script>
  <!-- jQuery -->
  <script type="text/javascript" src="<?php bloginfo('template_url'); ?>/js/libs/jquery-1.8.2.min.js"></script>
  <!-- framework css -->
  <link type="text/css" rel="stylesheet" href="<?php bloginfo('template_url'); ?>/css/groundwork.css">
  <link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
  <link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
  <!-- fonts -->
  
  <link href='http://fonts.googleapis.com/css?family=Open+Sans:400,300,300italic,400italic,600,600italic,700,700italic,800,800italic' rel='stylesheet' type='text/css'>

  <!--[if IE]>
  <link type="text/css" rel="stylesheet" href="<?php bloginfo('template_url'); ?>//css/groundwork-ie.css">
  <![endif]-->
  <!--[if lt IE 9]>
  <script type="text/javascript" src="<?php bloginfo('template_url'); ?>//js/libs/html5shiv.min.js"></script>
  <![endif]-->
  <!--[if IE 7]>
  <link type="text/css" rel="stylesheet" href="<?php bloginfo('template_url'); ?>//css/font-awesome-ie7.min.css">
  <![endif]-->
  <script type="text/javascript">
    // extend Modernizr to have datauri test
    (function(){
      var datauri = new Image();
      datauri.onerror = function() {
          Modernizr.addTest('datauri', function () { return false; });
      };
      datauri.onload = function() {
          Modernizr.addTest('datauri', function () { return (datauri.width == 1 && datauri.height == 1); });
          Modernizr.load({
            test: Modernizr.datauri,
            nope: '../css/no-datauri.css'
          });
      };
      datauri.src = "data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///ywAAAAAAQABAAACAUwAOw==";
    })();
    // fallback if SVG unsupported
    Modernizr.load({
      test: Modernizr.inlinesvg,
      nope: [
        '../css/no-svg.css'
      ]
    });
    // polyfill for HTML5 placeholders
    Modernizr.load({
      test: Modernizr.input.placeholder,
      nope: [
        '<?php bloginfo('template_url'); ?>/css/placeholder_polyfill.css',
        '<?php bloginfo('template_url'); ?>/js/libs/placeholder_polyfill.jquery.js'
      ]
    });
  </script>
  <?php
    /*
     *  Add this to support sites with sites with threaded comments enabled.
     */
    if ( is_singular() && get_option( 'thread_comments' ) )
        wp_enqueue_script( 'comment-reply' );
 
    wp_head();
     
    wp_get_archives('type=monthly&format=link');
  ?>
</head>
<body>
  <div class="loader">
  <div class="gray">
    <div class="mobile-hide"><img src="<?php bloginfo('template_url'); ?>/images/gray.png"/></div>
    <img src="<?php bloginfo('template_url'); ?>/images/blue.png" class="blue mobile-hide"/>
</div>
<div class="loading-bar"></div>
<p class="loading-type">Please wait...</p>
</div>